


function showMachinePlanEditModal(order_id, product_id, machinery_plan_id) {


    CUSTOMER_ORDER_PLAN_DATA_ID = order_id;
    FG_PRODUCT_ID = product_id;
    MACHINERY_PLAN_ID = machinery_plan_id;
    factories();
    clearAllocatedMachineTable();
    getSelectedProductDataEdit(order_id, product_id);
    $('#machinePlanModalEdit').modal('show');


}

function clearAllocatedMachineTable() {
    $('#tblAllocateProductEdit').empty();
    addMachineRow(0);
}


function addMachineRow(id) {
    $('#' + id).text("Remove");
    $('#' + id).attr('class', 'btn btn-danger remove');
    $('#' + id).attr('onclick', '');

    var btn_id = guidGenerator();
    var txtDate_id = "txtDate" + guidGenerator();
    var txtFrom_id = "txtFrom" + guidGenerator();
    var txtTo_id = "txtTo" + guidGenerator();
    var txtQty_id = "txtQty" + guidGenerator();
    var txtAllocatedQty_id = "allocatedQty" + guidGenerator();
    var txtOutput_id = "txtQty" + guidGenerator();
    var cmb_id = "cmb" + guidGenerator();

    var string_txtFrom_id = "'" + txtFrom_id + "'";
    var string_txtTo_id = "'" + txtTo_id + "'";
    var string_txtQty_id = "'" + txtQty_id + "'";
    var string_txtOutput_id = "'" + txtOutput_id + "'";
    var string_id = "'" + btn_id + "'";

    var row = '<tr id="' + id + '"><td><input id="' + txtDate_id + '" data-id="' + txtAllocatedQty_id + '" data-id2="' + txtFrom_id + '" data-id3="' + txtTo_id + '" type="text" class="form-control-sm" style="width:130px; border:1px solid gray;" name="dteDate" id="dteDate" autocomplete="off"></td>';
    row += '<td><input id="' + txtFrom_id + '" type="text" class="form-control-sm" style="width:50px; border:1px solid gray;" autocomplete="off" oninput="calculateOutput(' + string_txtFrom_id + ',' + string_txtTo_id + ',' + string_txtQty_id + ',' + string_txtOutput_id + ')"></td>';
    row += '<td><input id="' + txtTo_id + '" type="text" class="form-control-sm" style="width:50px; border:1px solid gray;" autocomplete="off" oninput="calculateOutput(' + string_txtFrom_id + ',' + string_txtTo_id + ',' + string_txtQty_id + ',' + string_txtOutput_id + ')"></td>';
    row += '<td><input id="' + txtQty_id + '" type="text" class="form-control-sm newQty" style="width:100px;text-align:right; border:1px solid gray;"  autocomplete="off" oninput="isCapacityExeeded(' + string_txtQty_id + ',' + string_txtOutput_id + ');validate_to_allocatedQty_to_productionQty()"></td>';
    row += '<td><input id="' + txtOutput_id + '" type="text" class="form-control-sm" style="width:100px;text-align:right; border:1px solid gray;" id="date" autocomplete="off" oninput="isCapacityExeeded(' + string_txtQty_id + ',' + string_txtOutput_id + ');"></td>';
    row += '<td><input id = "' + txtAllocatedQty_id + '" type="text" class="form-control-sm" style="width:100px; border:1px solid gray;" id="date" autocomplete="off"></td>';
    row += '<td><select id="' + cmb_id + '" class="form-control" style="width:200px;"></select></td>';
    row += '<td><button type="button" id="' + btn_id + '" class="btn btn-primary" onclick="addMachineRow(' + string_id + ')">Add</button></td></tr>';
    $('#tblAllocateProductEdit').append(row);

    $(".remove").click(function () {
        $(this).closest("tr").remove();
    });

    $('input[name="dteDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }
    });
    $('#' + txtDate_id).val('');
    $('input[name="dteDate"]').on('apply.daterangepicker', function (ev, picker) {
        var from = $('#' + $(this).attr('data-id2')).val();
        var to = $('#' + $(this).attr('data-id3')).val();
        var allocatedQty = getAllocatedQuantityFromDate(CUSTOMER_ORDER_PLAN_DATA_ID, FG_PRODUCT_ID, $('#cmbMachine').val(), $(this).val(), from, to);
        $('#' + $(this).attr('data-id')).val(allocatedQty);


    });



    allShift(cmb_id);
    return {
        "btn_id": btn_id,
        "date": $('#' + txtDate_id),
        "from": $('#' + txtFrom_id),
        "to": $('#' + txtTo_id),
        "quantity": $('#' + txtQty_id),
        "output": $('#' + txtOutput_id),
        "allocate": $('#' + txtAllocatedQty_id),
        "shift": $('#' + cmb_id),

    };

}




function allShift(id) {
    $.ajax({
        type: 'GET',
        url: '/pd/ProductionScheduleCreateController/allShift',
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {

                var html = '';
                $.each(response.data.result, function (index, value) {
                    html += '<option value="' + value.shift_id + '">' + value.shift_name + '</option>';
                })
                $('#' + id).html(html);
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
}




function loadMachinesToFactory(id) {
    $.ajax({
        type: 'GET',
        url: '/pd/ProductionScheduleCreateController/loadMachinesToFactory/' + id,
        async: false,
        success: function (response) {
            console.log(response.result)
            if (response.success) {
                $('#cmbMachineEdit').empty();
                $('#cmbMachineEdit').append('<option selected disabled>--Select Here--</option>');
                for (i = 0; i < response.result.length; i++) {
                    var id = response.result[i]['machinery_id'];
                    var no = response.result[i]['machinery_no'];
                    var name = response.result[i]['machinery_name'];
                    var nn = no + "-" + name;
                    $('#cmbMachineEdit').append('<option value="' + id + '">' + nn + '</option>');
                }


            }
        }, error: function (data) {
            console.log('something went wrong');
        }
    });
}




function guidGenerator() {
    var S4 = function () {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    return (S4() + S4());
}



function getAllocatedData(order_id, product_id, machine_id) {

    $.ajax({
        type: 'GET',
        url: '/pd/ProductionScheduleListController/getAllocatedData/' + order_id + "/" + product_id + "/" + machine_id,
        async: false,
        beforeSend: function () {
            //progress(true);
        },
        success: function (response) {
            console.log(response.data.result);
            var result = response.data.result;
            if (result.length > 0) {
                var childarray = { "btn_id": 0 };
                $('#tblAllocateProductEdit').empty();
                for (var i = 0; i < result.length; i++) {

                    childarray = addMachineRow(childarray.btn_id);
                    childarray.date.val(result[i].date);
                    childarray.from.val(result[i].from);
                    childarray.to.val(result[i].to).trigger("input");
                    childarray.quantity.val(result[i].quantity);
                    childarray.quantity.attr("class", "form-control-sm oldQty");
                    childarray.shift.val(result[i].shift_id);
                    childarray.date.trigger('apply.daterangepicker');

                }
                addMachineRow(childarray.btn_id);

            }

        },
        error: function (data) {

        },
        complete: function () {
            //progress(false);
        }
    });

}


function calculateOutput(from_id, to_id, qty_id, output_id) {

    var from = $('#' + from_id).val();
    var to = $('#' + to_id).val();
    var qty = $('#' + qty_id).val();
    var output = (to - from) * QUANTITY_PER_HOUR;
    if (output < 0) {
        output = 0;
    }
    $('#' + output_id).val(output);

}


function isCapacityExeeded(qty_id, output_id) {

    var qty = parseFloat($('#' + qty_id).val());
    var output = parseFloat($('#' + output_id).val());

    if (qty > output) {
        //showWarningMessage('Maximum capacity exeeded.');
        showWarningMessage("Maximum capacity exeeded.<br>Quantity :" + qty + "<br>Max Output Qty :" + output);

    }
}





function getAllocatedQuantityFromDate(order_id, product_id, machine_id, date, from, to) {

    var quantity = 0;
    $.ajax({
        type: 'GET',
        url: '/pd/ProductionScheduleCreateController/getAllocatedQuantityFromDate/' + order_id + "/" + product_id + "/" + machine_id + "/" + date + "/" + from + "/" + to,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.result != null) {
                quantity = response.data.result;
            }
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
    return quantity;
}


function validate_to_allocatedQty_to_productionQty() {

    var allocated_qty = parseFloat($('#lblAllocateQty').attr('data-id'));
    var production_qty = parseFloat($('#lblProductionQty').attr('data-id'));
    var qty_array = $('.newQty').map((_, el) => el.value).get();
    var new_allocated_qty = 0;
    for (var i = 0; i < qty_array.length; i++) {
        new_allocated_qty += parseFloat(qty_array[i]);
    }
    if (parseFloat(allocated_qty + new_allocated_qty) > production_qty) {
        showWarningMessage("Maximum capacity exeeded.<br>Production Qty :" + production_qty + "<br>Allocated Qty :" + parseFloat(allocated_qty + new_allocated_qty));
    }


}





function getSelectedProductDataEdit(order_id, product_id) {
    $.ajax({
        type: 'GET',
        url: '/pd/ProductionScheduleCreateController/getSelectedProductData/' + order_id + "/" + product_id,
        async: false,
        success: function (response) {
            console.log(response.data.result);
            if (response.data.success) {
                $('#lblProductCodeEdit').text(": " + response.data.result.product_code);
                $('#lblProductNameEdit').text(": " + response.data.result.product_name);
                $('#lblFactoryPOEdit').text(": " + response.data.result.factory_po);
                $('#lblCustomerPOEdit').text(": " + response.data.result.customer_po);
                $('#lblProductionQtyEdit').text(": " + response.data.result.quantity);
                $('#lblAllocateQtyEdit').text(": " + response.data.result.allocated_quantity);
                $('#lblFactoryEdit').text(": " + response.data.result.factory);
                $('#lblMachineEdit').text(": " + response.data.result.machine);
                QUANTITY_PER_HOUR = quantityPerHour(machine_id);
                getAllocatedData(CUSTOMER_ORDER_PLAN_DATA_ID, FG_PRODUCT_ID, machine_id);
                setSelectedOption('cmbFactoryEdit', '2');
                loadMachinesToFactory($('#cmbFactoryEdit').val());
                setSelectedOption('cmbMachineEdit', machine_id);
            }

        },
        error: function (data) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }
    });
}





function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}




function quantityPerHour(machine_id) {
    var quantity = 0;
    $.ajax({
        type: 'GET',
        url: '/pd/ProductionScheduleCreateController/quantityPerHour/' + machine_id,
        async: false,
        success: function (response) {
            console.log(response.data.result);

            quantity = parseFloat(response.data.result);
        },
        error: function (data) {

        },
        complete: function () {

        }
    });
    return quantity;
}








function saveAllocateToMachine() {

    $.ajax({
        type: "POST",
        url: '/pd/ProductionScheduleListController/saveAllocateToMachine',
        data: {
            "customer_order_plan_data_id": CUSTOMER_ORDER_PLAN_DATA_ID,
            'machinery_plan_id': MACHINERY_PLAN_ID,
            'machinery_id': $('#cmbMachineEdit').val(),
            "product_primary_id": FG_PRODUCT_ID,
            'data': dataSource(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('Data has been saved successful');
                clearAllocatedMachineTable();
                $('#cmbMachine').prop('selectedIndex', 0);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
            $('#machinePlanModalEdit').modal('hide');
        }

    });
}





function dataSource() {

    var collection = {};
    var table = document.getElementById('tblAllocateProductEdit'),
        rows = table.getElementsByTagName('tr'),
        i, j, cells, customerId;

    for (i = 0, j = rows.length; i < j; ++i) {
        cells = rows[i].getElementsByTagName('td');
        if (!cells.length) {
            continue;
        }
        var data = {
            "date": cells[0].childNodes[0].value,
            "from": cells[1].childNodes[0].value,
            "to": cells[2].childNodes[0].value,
            "quantity": cells[3].childNodes[0].value,
            "output": cells[4].childNodes[0].value,
            "allocated": cells[5].childNodes[0].value,
            "shift": cells[6].childNodes[0].value,
        };
        collection[i] = JSON.stringify(data);



    }

    return collection;
}



